Index: trunk/src/get_field/FFT.m
===================================================================
--- trunk/src/get_field/FFT.m	(revision 504)
+++ 	(revision )
@@ -1,103 +1,0 @@
-% 'FFT': calculate and display spectrum of the field selected in the GUI  get_field 
-%  GUI_input=FFT(hget_field)
-%
-% OUTPUT: 
-% GUI_input: option for display in the GUI get_field
-%
-%INPUT:
-% hget_field: handles of the GUI get_field
-%
-
-function GUI_input=FFT(hget_field)
-global spec x_vec
-%requests for the visibility of input windows in the GUI series  (activated directly by the selection in the menu ACTION)
-if ~exist('hget_field','var')
-    GUI_input={'check_1Dplot'};
-    return %exit the function 
-end
-GUI_input=[];
-%initiation
-hhget_field=guidata(hget_field);
-abscissa_list=get(hhget_field.abscissa,'String');
-val=get(hhget_field.abscissa,'Value');
-val=val(1);
-abscissa_name=abscissa_list{val};
-ordinate_list=get(hhget_field.ordinate,'String');
-val=get(hhget_field.ordinate,'Value');
-val=val(1); %take only the first variable in the list
-
-ordinate_name=ordinate_list{val};
-
-[Field,errormsg]=read_get_field(hget_field);
-if ~isempty(errormsg)
-    msgbox_uvmat('ERROR',['error in get_field/FFT input:' errormsg])
-    return
-end
-
-% get variable
-eval(['Var= Field.' ordinate_name ';']);
-np=size(Var);
-np_freq=floor(np(1)/2);
-dx=1;%default
-dfreq=1/np(1);%default frequency interval (abscissa= array index)
-sum_data=sum(Var,2);
-if ~isequal(abscissa_name,'')
-    eval(['Coord_x= Field.' abscissa_name ';']);
-    ind_select=find(~isinf(Coord_x)&~isnan(sum_data));%detect infinite values
-    Coord_x=Coord_x(ind_select);
-    Var=Var(ind_select,:);
-    diff_x=diff(Coord_x);
-    dx=min(diff_x);
-    %interpolate on a regular abscissa interval if needed
-    if (max(diff_x)-dx)> 0.001*dx || numel(ind_select)<np(1)
-        xequ=Coord_x(1):dx:Coord_x(end);%equal time spacingdx=
-        Var=interp1(Coord_x,Var,xequ); %interpolated func
-        np=size(Var);
-    end
- %   funcinterp=interp1(time,func,timeq); %interpolated func
-    dfreq=1/(Coord_x(end)-Coord_x(1));%frequency interval
-end
-freq_max=1/(2*dx);
-Var=Var-ones(np(1),1)*mean(Var,1); %substract mean value
-fourier=fft(Var);%take fft (complex)
-spec=abs(fourier).*abs(fourier);% take square of the modulus
-spec=spec(1:np_freq,:);%keep only the first half (the other is symmetric)
-
-%plot
-list_fig=get(hhget_field.list_fig,'String');
-val=get(hhget_field.list_fig,'Value');
-hfig=str2num(list_fig{val});% chosen figure number from tyhe GUI
-if isempty(hfig)
-    hfig=figure;
-else
-    figure(hfig);
-end
-haxes=findobj(hfig,'Type','axes');
-if ~isempty(haxes)
-    axes(haxes)
-end
-x_vec=linspace(dfreq,freq_max,np_freq);
-plot(x_vec',spec)
-xlabel('frequency (Hz)')
-ylabel('spectral intensity')
-grid on
-
-% 
-% 
-% np=length(funcinterp);
-% funcinterp=funcinterp-sum(funcinterp)/np; %substract mean
-% fourier=fft(funcinterp);%take fft (complex)
-% spec=abs(fourier).*abs(fourier);% take sqare of the modulus
-% spec=spec([1:floor(np/2)]);%keep only the first half (the other is symmetric)
-% eval(['Field.' varname '=spec;'])
-% Field
-% % dfreq=1/(time(end)-time(1));%frequency interval
-% % freq=[0:dfreq:(floor(np/2)-1)*dfreq];
-% % figure(1)
-% % hold on
-% % plot(freq,spec)
-% % xlabel('frequency (Hz)')
-% % ylabel('spectral intensity')
-% % title(['spectrum of' fields]);
-% % grid on
-%  
Index: trunk/src/get_field/FFT2.m
===================================================================
--- trunk/src/get_field/FFT2.m	(revision 504)
+++ 	(revision )
@@ -1,37 +1,0 @@
-% 'FFT': calculate and display spectrum of the field selected in the GUI  get_field 
-%  GUI_input=FFT(hget_field)
-%
-% OUTPUT: 
-% GUI_input: option for display in the GUI get_field
-%
-%INPUT:
-% hget_field: handles of the GUI get_field
-%
-
-function SubField=FFT2(hget_field)
-%% set the input elements needed on the GUI get_field when the action is selected in the menu ActionName
-if ~exist('hget_field','var') % case with no input parameter 
-    SubField={'CheckPlot1D','off';...% enable simple x/y plot ('off'/'on')
-        'CheckScalar','on';...%  enable scalar selection('off'/'on')
-        'CheckVector','off'; ...%  enable vector selection('off'/'on')
-               '',''};
-        return
-end
-%%%%%%%%%%%%%%%%%%%%%%%%%
-
-[SubField,errormsg]=read_get_field(hget_field);
-SubField
-for ilist=1:numel(SubField.ListVarName)
-    if isfield(SubField.VarAttribute{ilist},'Role') && isequal(SubField.VarAttribute{ilist}.Role,'scalar')
-        VarName=SubField.ListVarName{ilist};
-        spec=abs(fft2(SubField.(VarName)-mean(mean(SubField.(VarName)))));
-        SubField.(VarName)=log(spec);
-    end
-end
-  
-if ~isempty(errormsg)
-    msgbox_uvmat('ERROR',['error in read_get_field input:' errormsg])
-    return
-end
-SubField
-
Index: trunk/src/get_field/PLOT.m
===================================================================
--- trunk/src/get_field/PLOT.m	(revision 504)
+++ 	(revision )
@@ -1,22 +1,0 @@
-% 'PLOT.m': standar  display function for the the GUI  get_field 
-%  GUI_input=PLOT(hget_field)
-%
-% OUTPUT: 
-% GUI_input: option for display in the GUI get_field
-%
-%INPUT:
-% hget_field: handles of the GUI get_field
-%
-
-%---------------------------------------------------------
-% --- Executes on button press in RUN.
-function SubField=PLOT(hget_field)
-%---------------------------------------------------------
-SubField=[]; %default
-if ~exist('hget_field','var')
-    return
-end
-[SubField,errormsg]=read_get_field(hget_field);
-if ~isempty(errormsg)
-    msgbox_uvmat('ERROR',['error in read_get_field/PLOT input:' errormsg])
-end
Index: trunk/src/get_field/filter_band.m
===================================================================
--- trunk/src/get_field/filter_band.m	(revision 504)
+++ 	(revision )
@@ -1,38 +1,0 @@
-% 'filter_band.m': plot a field after band filtering in the GUI get_field 
-%  GUI_input=filter_band(hget_field)
-%
-% OUTPUT: 
-% GUI_input: option for display in the GUI get_field
-%
-%INPUT:
-% hget_field: handles of the GUI get_field
-%
-function filter_band(Field,hget_field)
-
-if ~isempty(VarIndex.x)
-    VarName_x=Field.ListVarName{VarIndex.x};
-end
-
-prompt={'selected period (nbre of points)'};
-   def={'10'};
-   dlgTitle='primary period';
-   lineNo=1;
-   answer=inputdlg(prompt,dlgTitle,lineNo,def);
-period=round(str2num(answer{1}));
-filt_vector=ones(1,period)/period;% averaging vector
-VarName_y=Field.ListVarName(VarIndex.y);
-% hfig
-if isempty(str2num(hfig))
-    figure
-else
-figure(str2num(hfig))
-end
-for ivar=1:length(VarName_y)
-    eval(['Var= filter(filt_vector,1,Field.' VarName_y{ivar} ');']);
-
-    plot(Var)
-    grid on
-    hold on
-end
-
- 