Index: trunk/src/set_object.m
===================================================================
--- trunk/src/set_object.m	(revision 680)
+++ trunk/src/set_object.m	(revision 681)
@@ -36,5 +36,5 @@
 function varargout = set_object(varargin)
 
-% Last Modified by GUIDE v2.5 28-Aug-2013 20:41:02
+% Last Modified by GUIDE v2.5 02-Sep-2013 11:39:56
 
 % Begin initialization code - DO NOT REFRESH
@@ -93,5 +93,4 @@
     ZBounds=0; %default 
 end
-set(handles.Coord,'KeyPressFcn',{@key_press_fcn,handles})%set keyboard action function (allow action on uvmat when set_object is in front)
 set(hObject,'WindowButtonDownFcn',{'mouse_down'})%set mouse click action function
 set(hObject,'DeleteFcn',{@closefcn})
@@ -116,5 +115,5 @@
     end
     Type_Callback(hObject, eventdata, handles)% update the GUI set_object depending on the object type   
-
+    set(handles.REFRESH,'BackgroundColor',[1 0 0])
     if isfield(data,'RangeZ') && length(ZBounds) >= 2
         set(handles.num_RangeZ_2,'String',num2str(max(data.RangeZ),3))
@@ -219,5 +218,5 @@
 function Type_Callback(hObject, eventdata, handles)
 %------------------------------------------------------------------------
-%style_prev=get(handles.Type,'UserData');%previous object style
+
 ListType=get(handles.Type,'String');
 Type=ListType{get(handles.Type,'Value')};
@@ -271,6 +270,7 @@
 % --- Executes on selection change in ProjMode.
 %------------------------------------------------------------------------
-
 function ProjMode_Callback(hObject, eventdata, handles)
+
+set(handles.REFRESH,'BackgroundColor',[1 0 1])
 menu=get(handles.ProjMode,'String');
 value=get(handles.ProjMode,'Value');
@@ -419,5 +419,5 @@
 function REFRESH_Callback(hObject, eventdata, handles)
 
-set(handles.REFRESH,'BackgroundColor',[1 1 0])
+set(handles.REFRESH,'BackgroundColor',[1 1 0])% indicate activation of REFRESH
 drawnow
 
@@ -588,5 +588,9 @@
 set(hhuvmat.CheckEditObject,'Value',1) % set uvmat to object edit mode to allow further object update
 set(hhuvmat.CheckViewField,'Value',1)
+
 set(handles.REFRESH,'BackgroundColor',[1 0 0])
+%set(handles.Coord,'BackgroundColor',[1 1 1])
+set(handles.num_RangeY_2,'BackgroundColor',[1 1 1])
+
 %------------------------------------------------------------------------
 % --- Executes on button press in MenuCoord.
@@ -617,4 +621,5 @@
 
 function num_RangeX_2_Callback(hObject, eventdata, handles)
+
 %------------------------------------------------------------------------
 %------------------------------------------------------------------------
@@ -720,4 +725,5 @@
 function Coord_CellEditCallback(hObject, eventdata, handles)
 %------------------------------------------------------------------------
+%set(handles.Coord,'BackgroundColor',[1 1 0])
 % ListType=get(handles.Type,'String');
 % Type=ListType{get(handles.Type,'Value')};
@@ -744,9 +750,19 @@
 end
 
-%------------------------------------------------------------------------
-% --- 'key_press_fcn:' function activated when a key is pressed on the keyboard
-%------------------------------------------------------------------------
-function key_press_fcn(hObject,eventdata,handles)
-
+
+function num_Angle_3_Callback(hObject, eventdata, handles)
+
+%------------------------------------------------------------------------
+% --- Executes on key press with selection of a uicontrol
+%------------------------------------------------------------------------
+function KeyPressFcn(hObject, eventdata, handles)
+set(handles.REFRESH,'BackgroundColor',[1 0 1])% se REFRESH to magenta color, indicates that refresh needs to be done
+
+%------------------------------------------------------------------------
+% --- Executes on key press with focus on Coord and none of its controls.
+%------------------------------------------------------------------------
+function Coord_KeyPressFcn(hObject, eventdata, handles)
+
+set(handles.REFRESH,'BackgroundColor',[1 0 1])
 xx=double(get(handles.set_object,'CurrentCharacter')); %get the keyboard character
 if ismember(xx,[127 31])% delete, or downward
@@ -763,9 +779,4 @@
 end
 
-function num_Angle_3_Callback(hObject, eventdata, handles)
-% hObject    handle to num_Angle_3 (see GCBO)
-% eventdata  reserved - to be defined in a future version of MATLAB
-% handles    structure with handles and user data (see GUIDATA)
-
-% Hints: get(hObject,'String') returns contents of num_Angle_3 as text
-%        str2double(get(hObject,'String')) returns contents of num_Angle_3 as a double
+
+